<!--
# Before Submitting

Please read this instructions carefully!

1. If it is not reported according to this issue template, it may be closed unconditionally
2. In accordance with "Issue Type", you should uncomment below "EDITING AREA" corresponding the part
3. You checked the [FAQ](https://github.com/zplug/zplug/wiki/FAQ) for common problems.
4. Check your [requirements](https://github.com/zplug/zplug/wiki/FAQ#what-are-the-requirements) are satisfied.
-->

<!-- Check at least one that applies below: -->

- Type:
    - [ ] Bug
    - [ ] Enhancement
    - [ ] Feature Request
    - [ ] Question

---

- `zplug --version`: <!-- REPLACE ME -->
- `zsh --version`: <!-- REPLACE ME -->
- `uname -a`: <!-- REPLACE ME -->

<!-- EDITING AREA -->

<!-- Type: Bug

## Minimal zshrc (with less than 30 lines)

Create a minimal reproducing set of configurations for this issue. Please remove all unnecessary parts!

```zsh
source ~/.zplug/init.zsh

#zplug "foo/bar", tag:baz
#zplug "...

if zplug check || zplug install; then
  zplug load --verbose
fi
```

## Step to reproduce

1. REPLACE ME
2. REPLACE ME
3. ...

-->

<!-- Type: Enhancement
Please give us a pull request if possible!
-->

<!-- Type: Feature Request

Please give us a pull request if possible!

## What you want

REPLACE ME: Specifically describe the details of the function you want

## Usage

REPLACE ME: Please tell us the specific usage scene. What kind of convenience does it provide?

-->

<!-- Type: Question

Warning: Basically, GitHub Issues is an issue tracker and not a place to ask questions. Please refrain from as much as possible. In zplug, we provide Slack team instead: https://zplug.herokuapp.com

-->
